/*******************************************************************
*  DDESVR.CXX
*  (c) 1992-1994 STAR DIVISION
*******************************************************************/

#include "ddeimp.hxx"
#include "svdde.hxx"

static long         hCurConv  = 0;
static DWORD        hDdeInst  = NULL;
static short        nInstance = 0;
static DdeServices* pServices;

// --- DdeInternat::SvrCallback() ----------------------------------

#ifdef WNT
HDDEDATA CALLBACK DdeInternal::SvrCallback(
            WORD nCode, WORD nCbType, HCONV hConv, HSZ hText1, HSZ hText2,
            HDDEDATA hData, DWORD, DWORD )
#else
HDDEDATA CALLBACK _export DdeInternal::SvrCallback(
            WORD nCode, WORD nCbType, HCONV hConv, HSZ hText1, HSZ hText2,
            HDDEDATA hData, DWORD, DWORD )
#endif
{
    DdeServices&    rAll = (DdeServices&) DdeService::GetServices();
    DdeService*     pService;
    DdeTopic*       pTopic;
    DdeItem*        pItem;
    DdeData*        pData;
    Conversation*   pC;

    switch( nCode )
    {
        case XTYP_WILDCONNECT:
        {
            short nTopics = 0;

            for( pService = rAll.First();pService;pService = rAll.Next() )
            {
                if ( !hText2 || ( *pService->pName == hText2 ) )
                {
                    for( pTopic = pService->aTopics.First(); pTopic;
                         pTopic = pService->aTopics.Next() )
                    {
                        if ( !hText1 || (*pTopic->pName == hText1) )
                            nTopics++;
                    }
                }
            }

            if ( !nTopics )
                return (HDDEDATA)NULL;

            HSZPAIR* pPairs = new HSZPAIR [nTopics + 1];
            if ( !pPairs )
                return (HDDEDATA)NULL;

            HSZPAIR* q = pPairs;
            for( pService = rAll.First(); pService; pService = rAll.Next() )
            {
                if ( !hText2 || (*pService->pName == hText2 ) )
                {
                    for ( pTopic = pService->aTopics.First(); pTopic;
                          pTopic = pService->aTopics.Next() )
                    {
                        if ( !hText1 || (*pTopic->pName == hText1) )
                        {
                            q->hszSvc   = *pService->pName;
                            q->hszTopic = *pTopic->pName;
                            q++;
                        }
                    }
                }
            }

            q->hszSvc   = NULL;
            q->hszTopic = NULL;
            HDDEDATA h = DdeCreateDataHandle(
                            hDdeInst, (LPBYTE) pPairs,
                            sizeof(HSZPAIR) * (nTopics+1),
                            0, NULL, nCbType, 0);
            delete pPairs;
            return h;
        }

        case XTYP_CONNECT:
            pService = FindService( hText2 );
            if ( pService)
                pTopic = FindTopic( pService->aTopics, hText1 );
            else
                pTopic = NULL;
            if ( pTopic )
                return (HDDEDATA)DDE_FACK;
            else
                return (HDDEDATA) NULL;

        case XTYP_CONNECT_CONFIRM:
            pService = FindService( hText2 );
            if ( pService )
            {
                pTopic = FindTopic( pService->aTopics, hText1 );
                if ( pTopic )
                {
                    pTopic->Connect( (long) hConv );
                    pC = new Conversation;
                    pC->hConv = hConv;
                    pC->pTopic = pTopic;
                    pService->pConv->Insert( pC );
                }
            }
            return (HDDEDATA)NULL;
    }

    for ( pService = rAll.First(); pService; pService = rAll.Next() )
    {
        for( pC = pService->pConv->First(); pC;
             pC = pService->pConv->Next() )
        {
            if ( pC->hConv == hConv )
                goto found;
        }
    }

    return (HDDEDATA) DDE_FNOTPROCESSED;

found:
    if ( nCode == XTYP_DISCONNECT)
    {
        pC->pTopic->Disconnect( (long) hConv );
        pService->pConv->Remove( pC );
        delete pC;
        return (HDDEDATA)NULL;
    }

    BOOL bExec = BOOL(nCode == XTYP_EXECUTE);
    pTopic = pC->pTopic;
    if ( pTopic && !bExec )
        pItem = FindItem( pTopic->aItems, hText2 );
    else
        pItem = NULL;

    if ( !bExec && !pService->HasCbFormat( nCbType ) )
        pItem = NULL;
    if ( !pItem && !bExec )
        return (HDDEDATA)DDE_FNOTPROCESSED;
    if ( pItem )
        pTopic->aItem = pItem->GetName();
    else
        pTopic->aItem = "";

    BOOL bRes = FALSE;
    hCurConv = (long)hConv;
    switch( nCode )
    {
        case XTYP_REQUEST:
        case XTYP_ADVREQ:
            if ( pTopic->IsSystemTopic() )
            {
                String aRes;
                if ( pTopic->aItem == SZDDESYS_ITEM_TOPICS )
                    aRes = pService->Topics();
                else if ( pTopic->aItem == SZDDESYS_ITEM_SYSITEMS )
                    aRes = pService->SysItems();
                else if ( pTopic->aItem == SZDDESYS_ITEM_STATUS )
                    aRes = pService->Status();
                else if ( pTopic->aItem == SZDDESYS_ITEM_FORMATS )
                    aRes = pService->Formats();
                else if ( pTopic->aItem == SZDDESYS_ITEM_HELP )
                    aRes = pService->GetHelp();
                if ( aRes.Len() )
                    pData = new DdeData( aRes );
                else
                    pData = NULL;
            }
            else
                pData = pTopic->Get( DdeData( NULL, 0, nCbType ).GetFormat() );

            if ( pData )
                return DdeCreateDataHandle( hDdeInst,
                                            (LPBYTE)pData->pImp->pData, pData->pImp->nData,
                                            0, hText2, pData->pImp->nFmt, 0);
            else
                break;

        case XTYP_POKE:
            if ( !pTopic->IsSystemTopic() )
            {
                DdeData d;
                d.pImp->hData = hData;
                d.pImp->nFmt  = nCbType;
                d.Lock();
                bRes = pTopic->Put( &d );
            }
            hCurConv = NULL;
            if ( bRes )
                return (HDDEDATA)DDE_FACK;
            else
                return (HDDEDATA) DDE_FNOTPROCESSED;

        case XTYP_ADVSTART:
            hCurConv = NULL;
            pItem->nMonitor++;
            return (HDDEDATA)TRUE;
        case XTYP_ADVSTOP:
            hCurConv = NULL;
            if ( pItem->nMonitor)
                pItem->nMonitor--;
            return (HDDEDATA)TRUE;

        case XTYP_EXECUTE:
            {
                DdeData aExec;
                aExec.pImp->hData = hData;
                aExec.pImp->nFmt  = nCbType;
                aExec.Lock();
                String aName( aExec.pImp->pData );
                bRes = pTopic->Execute( &aName );
            }
            hCurConv = NULL;
            if ( bRes )
                return (HDDEDATA)DDE_FACK;
            else
                return (HDDEDATA)DDE_FNOTPROCESSED;
    }

    return (HDDEDATA)NULL;
}

// --- DdeInternat::FindService() ----------------------------------

DdeService* DdeInternal::FindService( HSZ hService )
{
    DdeService*  s;
    DdeServices& rSvc = DdeService::GetServices();
    for ( s = rSvc.First(); s; s = rSvc.Next() )
    {
        if ( *s->pName == hService )
            return s;
    }

    return NULL;
}

// --- DdeInternat::FindTopic() ------------------------------------

DdeTopic* DdeInternal::FindTopic( DdeTopics& rTopics, HSZ hTopic )
{
    DdeTopic* s;
    for ( s = rTopics.First(); s; s = rTopics.Next() )
    {
        if ( *s->pName == hTopic )
            return s;
    }

    return NULL;
}

// --- DdeInternat::FindItem() -------------------------------------

DdeItem* DdeInternal::FindItem( DdeItems& rItems, HSZ hItem )
{
    DdeItem* s;

    for ( s = rItems.First(); s; s = rItems.Next() )
    {
        if ( *s->pName == hItem )
            return s;
    }

    return NULL;
}

// --- DdeService::DdeService() ------------------------------------

DdeService::DdeService( const String& rService )
{
    if ( !nInstance++ )
    {
        nStatus = DdeInitialize( &hDdeInst, (PFNCALLBACK)DdeInternal::SvrCallback,
                                 APPCLASS_STANDARD | CBF_SKIP_REGISTRATIONS |
                                 CBF_SKIP_UNREGISTRATIONS, 0L );
        pServices = new DdeServices;
    }
    else
        nStatus = DMLERR_NO_ERROR;

    pConv = new ConvList;

    if ( pServices )
        pServices->Insert( this );

    pName = new DdeString( hDdeInst, rService );
    if ( nStatus == DMLERR_NO_ERROR )
        if ( !DdeNameService( hDdeInst, *pName, NULL, DNS_REGISTER ) )
            nStatus = DMLERR_SYS_ERROR;

    AddFormat( FORMAT_STRING );
    pSysTopic = new DdeTopic( SZDDESYS_TOPIC );
    pSysTopic->AddItem( DdeItem( SZDDESYS_ITEM_TOPICS ) );
    pSysTopic->AddItem( DdeItem( SZDDESYS_ITEM_SYSITEMS ) );
    pSysTopic->AddItem( DdeItem( SZDDESYS_ITEM_STATUS ) );
    pSysTopic->AddItem( DdeItem( SZDDESYS_ITEM_FORMATS ) );
    pSysTopic->AddItem( DdeItem( SZDDESYS_ITEM_HELP ) );
    AddTopic( *pSysTopic );
}

// --- DdeService::~DdeService() -----------------------------------

DdeService::~DdeService()
{
    DdeNameService( hDdeInst, *pName, NULL, DNS_UNREGISTER );

    if ( pServices )
        pServices->Remove( this );
    delete pSysTopic;
    delete pName;

    if ( !--nInstance && hDdeInst )
    {
        DdeUninitialize( hDdeInst );
        hDdeInst = NULL;
        delete pServices;
        pServices = NULL;
    }

    delete pConv;
}

// --- DdeService::GetName() ---------------------------------------

const String& DdeService::GetName()
{
    return (const String&)*pName;
}

// --- DdeService::GetServices() -----------------------------------

DdeServices& DdeService::GetServices()
{
    return *pServices;
}

// --- DdeService::AddTopic() --------------------------------------

void DdeService::AddTopic( const DdeTopic& rTopic )
{
    RemoveTopic( rTopic );
    aTopics.Insert( (DdeTopic*) &rTopic );
}

// --- DdeService::RemoveTopic() -----------------------------------

void DdeService::RemoveTopic( const DdeTopic& rTopic )
{
    DdeTopic* t;
    for ( t = aTopics.First(); t; t = aTopics.Next() )
    {
        if ( !DdeCmpStringHandles (*t->pName, *rTopic.pName ) )
        {
            aTopics.Remove( t );
            break;
        }
    }
}

// --- DdeService::HasCbFormat() -----------------------------------

BOOL DdeService::HasCbFormat( short nFmt )
{
    return BOOL( aFormats.GetPos( nFmt ) != LIST_ENTRY_NOTFOUND );
}

// --- DdeService::HasFormat() -------------------------------------

BOOL DdeService::HasFormat( ULONG nFmt )
{
    DdeData d( NULL, 0, nFmt );
    return HasCbFormat( d.pImp->nFmt );
}

// --- DdeService::AddFormat() -------------------------------------

void DdeService::AddFormat( ULONG nFmt )
{
    DdeData d( NULL, 0, nFmt );
    aFormats.Remove( (long)d.pImp->nFmt );
    aFormats.Insert( (long)d.pImp->nFmt );
}

// --- DdeService::RemoveFormat() ----------------------------------

void DdeService::RemoveFormat( ULONG nFmt )
{
    DdeData d( NULL, 0, nFmt );
    aFormats.Remove( (long)d.pImp->nFmt );
}

// --- DdeTopic::DdeTopic() ----------------------------------------

DdeTopic::DdeTopic( const String& rName )
{
    pName = new DdeString( hDdeInst, rName );
}

// --- DdeTopic::~DdeTopic() ---------------------------------------

DdeTopic::~DdeTopic()
{
    DdeItem* t;
    while( ( t = aItems.First() ) != NULL )
        aItems.Remove( t );
    delete pName;
}

// --- DdeTopic::GetName() -----------------------------------------

const String& DdeTopic::GetName()
{
    return (const String&)*pName;
}

// --- DdeTopic::IsSystemTopic() -----------------------------------

BOOL DdeTopic::IsSystemTopic()
{
    return BOOL (GetName() == SZDDESYS_TOPIC);
}

// --- DdeTopic::AddItem() -----------------------------------------

void DdeTopic::AddItem( const DdeItem& r )
{
    DdeItem* s = new DdeItem( r );
    if ( s )
        aItems.Insert( s );
}

// --- DdeTopic::RemoveItem() --------------------------------------

void DdeTopic::RemoveItem( const DdeItem& r )
{
    DdeItem* s;
    for ( s = aItems.First(); s; s = aItems.Next() )
    {
        if ( !DdeCmpStringHandles (*s->pName, *r.pName ) )
            break;
    }

    if ( s )
    {
        aItems.Remove( s );
        delete s;
    }
}

// --- DdeTopic::NotifyClient() ------------------------------------

void DdeTopic::NotifyClient( const String& rItem )
{
    DdeItem* pItem;
    for ( pItem = aItems.First(); pItem; pItem = aItems.Next() )
    {
        if ( pItem->GetName() == rItem )
        {
            if ( pItem->nMonitor )
                DdePostAdvise( hDdeInst, *pName, *pItem->pName );
        }
        break;
    }
}

// --- DdeTopic::Connect() -----------------------------------------

void DdeTopic::Connect( long nId )
{
    aConnectLink.Call( (void*)nId );
}

// --- DdeTopic::Disconnect() --------------------------------------

void DdeTopic::Disconnect( long nId )
{
    aDisconnectLink.Call( (void*)nId );
}

// --- DdeTopic::Get() ---------------------------------------------

DdeData* DdeTopic::Get( ULONG nFmt )
{
    if ( aGetLink.IsSet() )
        return (DdeData*)aGetLink.Call( (void*)nFmt );
    else
        return NULL;
}

// --- DdeTopic::Put() ---------------------------------------------

BOOL DdeTopic::Put( const DdeData* r )
{
    if ( aPutLink.IsSet() )
        return (BOOL)aPutLink.Call( (void*) r );
    else
        return FALSE;
}

// --- DdeTopic::Execute() -----------------------------------------

BOOL DdeTopic::Execute( const String* r )
{
    if ( aExecLink.IsSet() )
        return (BOOL)aExecLink.Call( (void*)r );
    else
        return FALSE;
}

// --- DdeTopic::GetConvId() ---------------------------------------

long DdeTopic::GetConvId()
{
    return hCurConv;
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const char* p )
{
    pName = new DdeString( hDdeInst, p );
    nMonitor = 0;
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const String& r)
{
    pName = new DdeString( hDdeInst, r );
    nMonitor = 0;
}

// --- DdeItem::DdeItem() ------------------------------------------

DdeItem::DdeItem( const DdeItem& r)
{
    pName = new DdeString( hDdeInst, *r.pName );
    nMonitor = 0;
}

// --- DdeItem::~DdeItem() -----------------------------------------

DdeItem::~DdeItem()
{
    delete pName;
}

// --- DdeItem::GetName() ------------------------------------------

const String& DdeItem::GetName()
{
    return (const String&) *pName;
}

// --- DdeService::SysItems() --------------------------------------

String DdeService::SysItems()
{
    String s;
    DdeTopic* t;
    for ( t = aTopics.First(); t; t = aTopics.Next() )
    {
        if ( t->GetName() == SZDDESYS_TOPIC )
        {
            short n = 0;
            DdeItem* pi;
            for ( pi = t->aItems.First(); pi; pi = t->aItems.Next(), n++ )
            {
                if ( n )
                    s += '\t';
                s += pi->GetName();
            }
            s += "\r\n";
        }
    }

    return s;
}

// --- DdeService::Topics() ----------------------------------------

String DdeService::Topics()
{
    String      s;
    DdeTopic*   t;
    short       n = 0;

    for ( t = aTopics.First(); t; t = aTopics.Next(), n++ )
    {
        if ( n )
            s += '\t';
        s += t->GetName();
    }
    s += "\r\n";

    return s;
}

// --- DdeService::Formats() ---------------------------------------

String DdeService::Formats()
{
    String      s;
    long        f;
    char        buf[128], *p;
    short       n = 0;

    for ( f = aFormats.First(); f; f = aFormats.Next(), n++ )
    {
        if ( n )
            s += '\t';
        p = buf;

        switch( (USHORT)f )
        {
            case CF_TEXT:
                p = "TEXT";
                break;
            case CF_BITMAP:
                p = "BITMAP";
                break;
            default:
                GetClipboardFormatName( (UINT)f, buf, 128 );
        }
        s += String( p );
    }
    s += "\r\n";

    return s;
}

// --- DdeService::Status() ----------------------------------------

String DdeService::Status()
{
    return String( IsBusy() ? "Busy\r\n" : "Ready\r\n" );
}

// --- DdeService::IsBusy() ----------------------------------------

BOOL DdeService::IsBusy()
{
    return FALSE;
}

// --- DdeService::GetHelp() ----------------------------------------

String DdeService::GetHelp()
{
    return String();
}
